unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, OleCtrls, SHDocVw, ComCtrls, FileCtrl, Buttons,
  ToolWin, ExtCtrls, ImgList, DB, ADODB, Grids, DBGrids, jpeg, MPlayer, ActiveX, mmSystem;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    MediaPlayer1: TMediaPlayer;
    ProgressBar1: TProgressBar;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel4: TPanel;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ProgressBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  FileName: string ='';

implementation


{$R *.dfm}
 procedure SetVolume(const volL, volR: Word);
 var
   hWO: HWAVEOUT;
   waveF: TWAVEFORMATEX;
   vol: DWORD;
 begin
   // init TWAVEFORMATEX
  FillChar(waveF, SizeOf(waveF), 0);
   // open WaveMapper = std output of playsound
  waveOutOpen(@hWO, WAVE_MAPPER, @waveF, 0, 0, 0);
   vol := volL + volR shl 16;
   // set volume
  waveOutSetVolume(hWO, vol);
   waveOutClose(hWO);
 end;

procedure TForm2.FormCreate(Sender: TObject);
begin
//  ,    1
MediaPlayer1.Display:=Form2.Panel1;
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
// ,   
Application.Terminate;
end;

//     
procedure TForm2.ProgressBar1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
  p: real;
begin
if MediaPlayer1.FileName<>'' then  begin
  if ssleft in shift then
  begin
    p:=ProgressBar1.Max/ProgressBar1.Width;
    ProgressBar1.Position:=round(x*p);
    MediaPlayer1.Position:=ProgressBar1.Position;
    MediaPlayer1.Play;
  end;
end;
end;

procedure TForm2.Timer1Timer(Sender: TObject);
var
TrackLen, TrackPos,TrackPosK, TrackPosS: Double;
ValPos: Double;
ValLen: Double;
begin
if MediaPlayer1.FileName<>'' then
begin
//  
MediaPlayer1.TimeFormat:=tfMilliseconds;
//     
ProgressBar1.Max:=MediaPlayer1.Length;
ProgressBar1.Position:=MediaPlayer1.Position;
//  
Form2.MediaPlayer1.DisplayRect := Form2.Panel1.ClientRect;

//      
TrackPos:=MediaPlayer1.Position/1000;
 //  
TrackLen:=MediaPlayer1.Length/1000;
//   
ValPos:=TrackPos / (24 * 3600);
ValLen:=TrackLen / (24 * 3600);
//       Label1  Label2
Label1.Caption:=' '+FormatDateTime('hh:mm:ss',ValPos);
Label2.Caption:=FormatDateTime('hh:mm:ss',ValLen)+' ';
//
SetVolume(round(TrackBar1.Position*655.35), round(TrackBar1.Position*655.35));
end;
end;

//
procedure TForm2.BitBtn2Click(Sender: TObject);
begin
if MediaPlayer1.Mode=mpPlaying then MediaPlayer1.PauseOnly;
end;

//
procedure TForm2.BitBtn3Click(Sender: TObject);
begin
if (MediaPlayer1.Mode=mpPlaying) or (MediaPlayer1.Mode=mpPaused) then MediaPlayer1.Stop;
end;

//  
procedure TForm2.BitBtn4Click(Sender: TObject);
begin
if (MediaPlayer1.Mode=mpPlaying) or (MediaPlayer1.Mode=mpPaused) then MediaPlayer1.Stop;
if OpenDialog1.Execute then
begin
FileName:=OpenDialog1.FileName;
Form2.Caption:=FileName;
end;
end;

//   
procedure TForm2.BitBtn1Click(Sender: TObject);
begin
if (FileName='') or (MediaPlayer1.Mode=mpPlaying) then exit;
begin
if MediaPlayer1.Mode=mpPaused then begin MediaPlayer1.Play;exit;end;
//   Play
MediaPlayer1.FileName:=FileName;
MediaPlayer1.Open; //     
Form2.MediaPlayer1.DisplayRect := Form2.Panel1.ClientRect;
Form2.MediaPlayer1.Play;
end;
end;

end.
